Preview a subscription
The REST API reference describes how to create a new subscription in preview mode. This call does not require a valid customer account. It can be used to show potential new customers a preview of a subscription with complete details and charges before creating an account, or to let existing customers preview a subscription with all charges before committing.
Notes:
-
The response of the Preview Subscription call is based on the REST API minor version you set in the request header. The response structure might be different if you use different minor version numbers.
-
If you have the Invoice Settlement feature enabled, we recommend that you set the
Zuora-Versionparameter to207.0or later available versions. Otherwise, an error is returned. -
Default values for customerAcceptanceDate and serviceActivationDate are set as follows.
Authentication
Use Bearer {{token}} in the Authorization header for authentication.
Headers
Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.
If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.
Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.
The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').
An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.
The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.
The minor API version.
For a list of available minor versions, see API upgrades.
Request
Effective contract date for this subscription, as yyyy-mm-dd.
Possible values are: TERMED, EVERGREEN.
Customer account number or ID.
You must specify the account information either in this field or in the previewAccountInfo field with the following conditions:
- If you already have a customer account, specify the account number or ID in this field.
- If you do not have a customer account, provide account information in the
previewAccountInfofield.
The date on which the services or products within a subscription have been accepted by the customer, as yyyy-mm-dd.
Default value is dependent on the value of other fields. See Notes section for more details.
The date of the billing document, in yyyy-mm-dd format. It represents the invoice date for invoices, credit memo date for credit memos, and debit memo date for debit memos.
- If this field is specified, the specified date is used as the billing document date.
- If this field is not specified, the date specified in the
targetDateis used as the billing document date.
Specifies whether to include draft invoice items in subscription previews. Values are:
true(default). Includes draft invoice items in the preview result.false. Excludes draft invoice items in the preview result. Note: This field is available only if you are on the latest Zuora API minor version, or you set theZuora-Versionrequest header to207.0or a later available version.
Duration of the first term of the subscription, in whole months. If termType is TERMED, then this field is required, and the value must be greater than 0. If termType is EVERGREEN, this field is ignored.
The period type of the initial term.
Supported values are:
MonthYearDayWeek
The default period type is Month.
Invoice owner account number or ID.
Note: This feature is in Limited Availability. If you wish to have access to the feature, submit a request at Zuora Global Support.
A container for providing a customer account information if you do not have an existing customer account. This customer account information is only used for subscription preview.
You must specify the account information either in this field or in the accountKey field with the following conditions:
- If you already have a customer account, specify the account number or ID in the accountKey field.
- If you do not have a customer account, provide account information in this field.
The type of preview you will receive.
Note: If your API minor version is earlier than 206.0 or you specify the Zuora-Version header for this request to 206.0 or earlier, the following values are supported for the previewType field:
InvoiceItem(default)ChargeMetricsInvoiceItemChargeMetrics
The date on which the services or products within a subscription have been activated and access has been provided to the customer, as yyyy-mm-dd.
Default value is dependent on the value of other fields. See Notes section for more details.
If set to true, the system will bypass the tax calculation during subscription preview.
Date through which to calculate charges if an invoice is generated, as yyyy-mm-dd. Default is current date.
Note: This field is only available if you are on the latest Zuora API minor version, or you set the Zuora-Version request header to 207.0 or a later available version.
The date on which the subscription term begins, as yyyy-mm-dd. If this is a renewal subscription, this date is different from the subscription start date.
Response headers
This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.
Note that only the following MIME types support gzipped responses:
application/jsonapplication/xmltext/htmltext/csvtext/plain
The request limit quota for the time window closest to exhaustion. See rate limits for more information.
The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.
The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.
The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.
For more information, see Concurrent request limits.
The total number of the permitted concurrent requests.
For more information, see Concurrent request limits.
The remaining number of the permitted concurrent requests.
For more information, see Concurrent request limits.
Response
Container for credit memos.
Note: This container is only available if you are on the latest Zuora API version or you set the Zuora-Version request header to 207.0 or a later available version, and you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information.
The date of the billing document, in yyyy-mm-dd format. It represents the invoice date for invoices, credit memo date for credit memos, and debit memo date for debit memos.
- If this field is specified, the specified date is used as the billing document date.
- If this field is not specified, the date specified in the
targetDateis used as the billing document date.
Container for invoices.
Note: This field is only available if you set the Zuora REST API minor version to 207.0 or a later available version in the request header. Also, the response structure is changed and the following invoice related response fields are moved to this invoice container:
- amount
- amountWithoutTax
- taxAmount
- invoiceItems
Returns true if the request was processed successfully.
Date through which to calculate charges if an invoice is generated, as yyyy-mm-dd. Default is current date.
Note: This field is only available if you set the Zuora REST API minor version to 207.0 or a later available version in the request header.